## mingw-w64-boost-1.85.0-1.src.tar.zst

=== libs/msm/CMakeLists.txt ===
# Generated by `boostdep --cmake msm`
# Copyright 2020 Peter Dimov
# Distributed under the Boost Software License, Version 1.0.
# https://www.boost.org/LICENSE_1_0.txt

cmake_minimum_required(VERSION 3.5...3.16)

project(boost_msm VERSION "${BOOST_SUPERPROJECT_VERSION}" LANGUAGES CXX)

add_library(boost_msm INTERFACE)
add_library(Boost::msm ALIAS boost_msm)

target_include_directories(boost_msm INTERFACE include)

target_link_libraries(boost_msm
  INTERFACE
    Boost::any
    Boost::assert
    Boost::bind
    Boost::circular_buffer
    Boost::config
    Boost::core
    Boost::function
    Boost::fusion
    Boost::mpl
    Boost::parameter
    Boost::phoenix
    Boost::preprocessor
    Boost::proto
    Boost::serialization
    Boost::tuple
    Boost::type_traits
    Boost::typeof
)

if(BUILD_TESTING AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test/CMakeLists.txt")

  add_subdirectory(test)

endif()
